import java.io.*;
import java.net.*;
import java.util.*;
import sv.data.*;
import sv.engine.SV2Protocol;

public class volumeTest {
  static String filename = ""; 
  static int xsize = 0, ysize = 0, zsize = 0;

  static boolean getInfo() {
    String yesno;

    try {
      BufferedReader reader = 
             new BufferedReader(new InputStreamReader(System.in));    

      System.out.print("Enter the data name without extension: ");
      filename = reader.readLine().trim();

      System.out.print("Enter the x dimension: ");
      xsize = Integer.parseInt(reader.readLine().trim());

      System.out.print("Enter the y dimension: ");
      ysize = Integer.parseInt(reader.readLine().trim());

      System.out.print("Enter the z dimension: ");
      zsize = Integer.parseInt(reader.readLine().trim());

      System.out.println("\nData name: " + filename);
      System.out.println("Dimension: " + xsize + ", " + ysize + ", " + zsize);
      System.out.print("\nAre you sure? (y/n) ");
      yesno = reader.readLine().trim();
      reader.close();

      if (yesno.equalsIgnoreCase("y"))
        return true;
      else 
        return false;

    } catch (Exception e) {
      return false;
    }
  }

  public static void main(String[] args) {
    String host = "osprey2";
    int port = 7653;       

    Socket sock = null;
    DataOutputStream out = null;
    long filesize = 0;

    try {
      if (!getInfo()) return;

      System.out.println("\n> Checking the file.");
      File datafile = new File(filename + ".den");
      if (!datafile.exists()) {
        System.out.println("Can't find data file " + filename + ".den.");
        System.exit(1);
      }
      filesize = datafile.length();
     
      int density_size = xsize * ysize * zsize;
      byte[] density = new byte[density_size];
      int  BRAIN_HEADER  = 62;

      System.out.println("> Reading the file.");
      RandomAccessFile in = new RandomAccessFile(datafile, "r");
      in.skipBytes(BRAIN_HEADER);
      in.readFully(density); 
      
      System.out.println("> Sending the data.");
      sock = new Socket(host, port);
      out = new DataOutputStream(sock.getOutputStream());
      out.writeInt(SV2Protocol.DEN_DATA_FEED);      

      // send data name
      byte[] byteArr = filename.getBytes();
      out.writeInt(byteArr.length); 
      out.write(byteArr, 0, byteArr.length);

      out.writeInt(xsize);    // send x size
      out.writeInt(ysize);    // send y size
      out.writeInt(zsize);    // send z size
      out.writeInt(density_size);
      out.write(density, 0, density_size);

    } catch (Exception e) {
      e.printStackTrace();
    }

    try {
      out.close();
      sock.close();
    } catch (Exception e) { }
  }
} // end of class

